package Dataflow;

import java.util.Enumeration;
import java.util.Vector;

public class ControlFlowGraph {
    Vector graph;

    public ControlFlowGraph () {
	// prelim 2 live variable analysis example
	int i, j;
	Node n[];
	Value v[];
	boolean direction = Analysis.BACKWARDS;
	int numnodes = 10;
	boolean succ[][] = {
	    { false, true, false, false, false,
	      false, false, false, false, false },
	    { false, false, true, false, false,
	      false, false, false, false, false },
	    { false, false, false, true, false,
	      false, true, false, false, false },
	    { false, false, false, false, true,
	      false, false, false, false, false },
	    { false, false, false, false, false,
	      true, false, false, false, false },
	    { true, false, false, false, false,
	      false, false, false, false, true },
	    { false, false, false, false, false,
	      false, false, true, false, false },
	    { false, false, false, false, false,
	      false, false, false, true, false },
	    { false, false, false, false, true,
	      false, false, false, false, false },
	    { false, false, false, false, false,
	      false, false, false, false, false },
	};
	boolean pred[][] = {
	    { false, false, false, false, false,
	      true, false, false, false, false },
	    { true, false, false, false, false,
	      false, false, false, false, false },
	    { false, true, false, false, false,
	      false, false, false, false, false },
	    { false, false, true, false, false,
	      false, false, false, false, false },
	    { false, false, false, true, false,
	      false, false, false, true, false },
	    { false, false, false, false, true,
	      false, false, false, false, false },
	    { false, false, true, false, false,
	      false, false, false, false, false },
	    { false, false, false, false, false,
	      false, true, false, false, false },
	    { false, false, false, false, false,
	      false, false, true, false, false },
	    { false, false, false, false, false,
	      true, false, false, false, false },
	};

	v = new Value[numnodes];
	for (i = 0; i < v.length; i++) {
	    v[i] = new Value (direction);
	}

	n = new Node[numnodes];
	for (i = 0; i < n.length; i++) {
	    n[i] = new Node ("n" + (i+1), v[i], direction);
	}

	for (i = 0; i < n.length; i++) {
	    for (j = 0; j < n.length; j++) {
		if (succ[i][j]) {
		    n[i].succ.addElement (n[j]);
		}
		if (pred[i][j]) {
		    n[i].pred.addElement (n[j]);
		}
	    }
	}

	graph = new Vector ();
	for (i = 0; i < n.length; i++) {
	    graph.addElement (n[i]);
	}
    }

    public Enumeration elements () {
	return graph.elements ();
    }

    public String toString () {
	Enumeration en;
	Node node;
	String s = "Name\t" + Node.HEADINGS + "\t" + Value.HEADINGS;
	en = graph.elements ();
	while (en.hasMoreElements ()) {
	    node = (Node) en.nextElement ();
	    s += "\n" + node + "\t" + node.value ();
	}
	return s;
    }
}
