package Dataflow;

import java.util.Enumeration;
import java.util.Vector;

public class Node {
    public Node (String name, Value dfv, boolean direction) {
	pred = new Vector ();
	succ = new Vector ();
	this.dfv = new Value (dfv);
	this.name = name;
	if (direction == Analysis.FORWARDS) {
	    upstream = pred;
	    downstream = succ;
	} else {
	    upstream = succ;
	    downstream = pred;
	}
	this.direction = direction;
    }
    public Vector pred, succ;	// of Node
    public Vector upstream, downstream; // aliases to pred and succ
    private Value dfv;
    private String name;
    public boolean direction;
    public Value value () { return new Value (dfv); }
    public String name () { return name; }

    public static final String HEADINGS = "Pred\tSucc";

    private String nodeString (Vector /* of Node */ c) {
	// Specific to this analysis.
	Enumeration en;
	String s = "";
	en = c.elements ();
	while (en.hasMoreElements ()) {
	    s += ((Node) en.nextElement ()).name ();
	}
	return s;
    }

    public String toString () {
	// Specific to this analysis.
	return name + "\t{" + nodeString (pred) + "}\t{" + 
	    nodeString (succ) + "}";
    }

    private void meet () {
	int entry;
	Enumeration en;
	entry = Value.TOP;
	en = upstream.elements ();
	while (en.hasMoreElements ()) {
	    // Meet operator is specific to each analysis.
	    entry = Value.TOP; //((Node) en.nextElement ()).value ().exit;
	}
	dfv.entry = entry;
    }

    public void flow () {
	meet ();
	// Flow function is specific to each analysis.
	dfv.exit = 0; // F(dfv.use,dfv.entry,dfv.def);
    }
}
