package Dataflow;

import java.util.Dictionary;
import java.util.Hashtable;
import java.util.EmptyStackException;

// FIFO queue
public class Queue {
    private QueueItem head, tail;
    private Dictionary dict; // O(1) lookup

    // Constructor
    public Queue () {
	head = null;
	dict = new Hashtable ();
    }

    // test
    public boolean isEmpty () {
	return head == null;
    }

    // test for inclusion
    public boolean contains (Object obj) {
	return dict.get (obj) != null;
    }

    // Peek
    public Object peek () throws EmptyStackException {
	if (head == null) {
	    throw new EmptyStackException ();
	}
	return head.elem;
    }

    // dequeue the first element of the queue and return it
    public Object remove () throws EmptyStackException {
	Object obj = peek ();
	head = head.next;
	dict.remove (obj);
	return obj;
    }

    // add an element to the very end
    public void add (Object obj) {
	QueueItem q = new QueueItem (obj);
	if (head == null) {
	    head = q;
	} else {
	    tail.next = q;
	}
	dict.put (obj, Boolean.TRUE);
	tail = q;
    }
}

class QueueItem {
    Object elem;
    QueueItem next;

    // a link plus some associated data
    QueueItem (Object obj) {
	elem = obj;
	next = null;
    }
}
